import shutil
from random import randint, seed
seed(47)

def UU(d): return 'U {}'.format(d)
def PP(x,y): return 'P {} {}'.format(x,y)

def gen1smart(P,U):
    commands = []
    for u in range(U):
        typ = randint(0,99)
        if 0 <= typ <= 59: commands.append( UU(1) )
        if 60 <= typ <= 96:
            x = randint( P//2, P )
            y = randint( P//2, P )
            if x > y: x, y = y, x
            commands.append( PP(x,y) )
        if 97 <= typ <= 99:
            x = randint( 1, P-4 )
            y = randint( x+1, x+4 )
            commands.append( PP(x,y) )
    return P,commands

def gen1rand(P,U):
    commands = []
    for u in range(U):
        typ = randint(0,99)
        if 0 <= typ <= 59: commands.append( UU(1) )
        if 60 <= typ <= 99:
            x = randint( 1, P )
            y = randint( 1, P )
            if x > y: x, y = y, x
            commands.append( PP(x,y) )
    return P,commands

def gen12(P,U):
    assert U >= P//2 + 7
    commands = []
    commands.append( UU(P-2) )
    for p in range(P//2):
        commands.append( PP(2*p+1,2*p+1) )
    while len(commands)+2 < U:
        if randint(0,19):
            commands.append( UU(2) )
            commands.append( PP(P-1,P) )
        else:
            commands.append( UU(1) )
    return P,commands

def genbig(P,U):
    commands = []
    for u in range(U):
        typ = randint(0,99)
        if 0 <= typ <= 39: commands.append( UU( randint(1,P) ) )
        if 40 <= typ <= 69:
            x = randint( 1, P//10 )
            y = randint( 3*P//10, P//3 )
            if x > y: x, y = y, x
            commands.append( PP(x,y) )
        if 70 <= typ <= 99:
            x = randint( 1+P//3, 4*P//10 )
            y = randint( 9*P//10, P )
            if x > y: x, y = y, x
            commands.append( PP(x,y) )
    return P,commands

def genmax(P,U,delta=10):
    commands = []
    for u in range(U//3):
        commands.append( UU( randint(P-2*delta,P-delta) ) )
        commands.append( PP( randint(1,delta), randint(P-delta+1,P) ) )
        commands.append( PP( randint(1,delta), randint(P-delta+1,P) ) )
    return P,commands

def gensqrt(P,U):
    lastend = -1
    segments = []
    for p in range(1,P+1):
        lo = lastend+2
        hi = lo+p-1
        if hi > P: break
        segments.append( (lo,hi) )
        lastend = hi

    commands = []
    commands.append( UU(P) )
    while len(commands) < U:
        if randint(0,1):
            x, y = segments[ randint(0,len(segments)-1) ]
            commands.append( PP(x,y) )
        else:
            x, y = segments[ randint(0,len(segments)-1) ]
            commands.append( UU(y-x+1) )
    return P,commands

def save(fname,P,commands):
    f = open(fname,'w')
    print(P,len(commands),file=f)
    for c in commands: print(c,file=f)
    f.close()

shutil.copy('old_data/01.in', '01.a.in')
shutil.copy('old_data/02.in', '01.b.in')
shutil.copy('old_data/03.in', '01.c.in')
save('01.d.in',*gen12(100,1000))
save('01.e.in',*genbig(100,1000))
save('01.f.in',*genmax(100,1000))
save('01.g.in',*gensqrt(100,1000))

shutil.copy('old_data/04.in', '02.a.in')
save('02.b.in',*gen12(50000,50000))
save('02.c.in',*genbig(50000,50000))
save('02.d.in',*gen1smart(50000,50000))
save('02.e.in',*genmax(50000,50000))
save('02.f.in',*gensqrt(50000,50000))

save('03.a.in',*gen12(150000,150000))
save('03.b.in',*genbig(150000,150000))
save('03.c.in',*gen1smart(150000,150000))
save('03.d.in',*genmax(150000,150000))
save('03.e.in',*gensqrt(150000,150000))

save('04.a.in',*gen1smart(500000,300000))
save('04.b.in',*gen1smart(499997,300000))
save('04.c.in',*gen1rand(500000,300000))
save('04.d.in',*gen1rand(499997,300000))

shutil.copy('old_data/06.in', '05.a.in')
shutil.copy('old_data/07.in', '05.b.in')
shutil.copy('old_data/08.in', '05.c.in')
shutil.copy('old_data/09.in', '05.d.in')
shutil.copy('old_data/10.in', '05.e.in')
shutil.copy('old_data/05.in', '05.f.in')
save('05.g.in',*gen12(500000,300000))
save('05.h.in',*genbig(500000,300000))
save('05.i.in',*genmax(500000,300000,1000))
save('05.j.in',*gensqrt(500000,300000))

# V prvej sade platí $p\leq 100$ a $u\leq 1000$.
# 
# V druhej sade platí $p,u\leq 50\,000$.
# 
# V tretej sade platí $p,u\leq 150\,000$.
# 
# V štvrtej a piatej sade platí $p\leq 500\,000$ a $u\leq 300\,000$. Vo štvrtej sade navyše
# pre každého umelca platí $d = 1$.
# 
# Vo všetkých sadách v každej udalosti platí $1\leq d\leq 10^9$ a $1\leq x\leq y\leq p$.
