#include <bits/stdc++.h>
using namespace std;

const int CISTY = 0, SPINAVY = 1, AKTUALNY = 2;
const int SQRT = 720;

struct vrchol { 
    int zaciatok, koniec, najviac, stav; 
    void zapln(int s) { stav = s; zaciatok = koniec = najviac = (s==CISTY ? SQRT : 0); }
};

vector<bool> panely;
vector<vrchol> useky;

void prepocitaj(int usek) {
    int z = 0; while (z < SQRT && panely[SQRT*usek+z]) ++z;
    useky[usek].zaciatok = z;

    int k = 0; while (k < SQRT && panely[SQRT*(usek+1)-1-k]) ++k;
    useky[usek].koniec = k;

    int rl = 0, maxl = 0;
    for (int i=0; i<SQRT; ++i) { if (panely[usek*SQRT+i]) { ++rl; maxl = max( maxl, rl ); } else { rl = 0; } }
    useky[usek].najviac = maxl;

    useky[usek].stav = AKTUALNY;
}

int najdi(int usek, int d) {
    assert(useky[usek].stav == AKTUALNY);
    int rl = 0, rs = 0;
    for (int i=0; i<SQRT; ++i) { if (panely[usek*SQRT+i]) { ++rl; if (rl >= d) return usek*SQRT+rs; } else { rl = 0; rs = i+1; } }
    assert(false);
}

void zapis(int usek) {
    if (useky[usek].stav == AKTUALNY) return;
    for (int i=0; i<SQRT; ++i) panely[usek*SQRT+i] = (useky[usek].stav == CISTY);
    prepocitaj(usek);
}

void zapis_dlhe(int started, int ended, bool co) {
    int su = started/SQRT, eu = ended/SQRT;
    if (su == eu) {
        zapis(su);
        for (int i=started; i<=ended; ++i) panely[i] = co;
        prepocitaj(su);
    } else {
        zapis(su);
        do { panely[started++] = co; } while (started % SQRT);
        prepocitaj(su);
        zapis(eu);
        do { panely[ended--] = co; } while ((ended+1) % SQRT);
        prepocitaj(eu);
        for (int u=su+1; u<eu; ++u) useky[u].zapln(co ? CISTY : SPINAVY);
    }
}

int main() {
    int P, U;
    scanf("%d %d ",&P,&U);

    panely.resize(SQRT*SQRT,false);
    for (int p=1; p<=P; ++p) panely[p] = true;
    useky.resize(SQRT);
    for (int usek=0; usek<SQRT; ++usek) prepocitaj(usek);

    while (U--) {
        char cmd;
        scanf("%c ",&cmd);
        if (cmd == 'U') {
            int d; scanf("%d ",&d);
            int running = 0, started = 0, found = -1;
            for (int usek = 0; usek < SQRT; ++usek) {
                running += useky[usek].zaciatok;
                if (running >= d) { found = started; break; }
                if (useky[usek].najviac >= d) { found = najdi(usek,d); break; }
                if (useky[usek].koniec < SQRT) {
                    running = useky[usek].koniec;
                    started = (usek+1)*SQRT - useky[usek].koniec;
                    if (running >= d) { found = started; break; }
                }
            }
            printf("%d\n",found);
            if (found != -1) zapis_dlhe(found,found+d-1,false);
        } else {
            int started, ended;
            scanf("%d %d ",&started,&ended);
            zapis_dlhe(started,ended,true);
        }
        /*
        cout << "debug\n";
        for (int u=0; u<SQRT; ++u) { 
            cout << useky[u].zaciatok << " " << useky[u].koniec << " " << useky[u].najviac << " " << useky[u].stav << " ";
            for (int i=0; i<SQRT; ++i) cout << int(panely[u*SQRT+i]);
            cout << endl;
        }
        */
    }
}
