#include <bits/stdc++.h>
using namespace std;

struct interval {
    int zac, kon;
    int dlzka() const { return kon-zac; }
};

bool operator< (const interval &A, const interval &B) { return A.zac < B.zac; }
bool operator<= (const interval &A, const interval &B) { return A.zac <= B.zac; }
bool operator== (const interval &A, const interval &B) { return A.zac == B.zac && A.kon == B.kon; }
ostream& operator<<(ostream &out, const interval &A) { return out << "[" << A.zac << "," << A.kon << "]"; }

bool intersect_or_touch(const interval &A, const interval &B) { return max(A.zac,B.zac) <= min(A.kon,B.kon); }

struct Treap {
    struct item {
        interval kluc;
        int priorita;
        int najdlhsi;
        item *l, *r;
        item(const interval &kluc) : kluc(kluc), priorita(rand()), najdlhsi(kluc.dlzka()), l(NULL), r(NULL) {}
    };

    typedef item* pitem;
    pitem root;

    Treap() : root(NULL) {}
    void insert(interval x) { insert(root,new item(x)); }
    void erase(interval x) { erase(root,x); }
    interval leftmost(int d) { if (!root) return {-1,-1}; return leftmost(root,d); }
    // void eraseall(interval x) { pitem l,m,r; split(root,x,l,r); split(l,x,l,m,false); merge(root,l,r); }

    interval leftmost(pitem t, int d) {
        if (t->l && t->l->najdlhsi >= d) return leftmost(t->l,d);
        if (t->kluc.dlzka() >= d) return t->kluc;
        if (t->r && t->r->najdlhsi >= d) return leftmost(t->r,d);
        return {-1,-1};
    }
    
    void update(pitem t) { 
        if (!t) return;
        t->najdlhsi = t->kluc.dlzka();
        if (t->l) t->najdlhsi = max( t->najdlhsi, t->l->najdlhsi );
        if (t->r) t->najdlhsi = max( t->najdlhsi, t->r->najdlhsi );
    }

    void split(pitem t, interval kluc, pitem &l, pitem &r, bool equal_left = true) {
        if (!t) { l = r = NULL; return; }
        if (equal_left ? (kluc < t->kluc) : (kluc <= t->kluc)) { split(t->l, kluc, l, t->l, equal_left); r = t; }
        else { split(t->r, kluc, t->r, r, equal_left); l = t; }
        update(t);
    }

    void merge(pitem &t, pitem l, pitem r) {
        if (!l || !r) { t = l ? l : r; return; }
        if (l->priorita > r->priorita) { merge(l->r, l->r, r); t = l; } else { merge(r->l, l, r->l); t = r; }
        update(t);
    }

    void insert(pitem &t, pitem it) {
        if (!t) { t = it; return; }
        if (it->priorita > t->priorita) { split(t, it->kluc, it->l, it->r); t = it; } else { insert(it->kluc < t->kluc ? t->l : t->r, it); }
        update(t);
    }

    void erase(pitem &t, interval kluc) {
        if (!t) return;
        if (t->kluc == kluc) merge(t, t->l, t->r); else erase(kluc < t->kluc ? t->l : t->r, kluc); 
        update(t);
    }

    void print(pitem t, int depth=0, ostream &out=cout) const {
        if (!t) return;
        out << string(2*depth,' ') << t->kluc << " (p " << t->priorita << " n " << t->najdlhsi << ")" << endl;
        out << string(2*depth,' ') << "left:" << endl;  print(t->l,depth+1);
        out << string(2*depth,' ') << "right:" << endl; print(t->r,depth+1);
    }
};
    
ostream& operator<< (ostream &out, const Treap &TM) { TM.print(TM.root,0,out); return out; }

int main() {
    int P, U;
    scanf("%d%d",&P,&U);

    Treap T;
    set<interval> S;
    T.insert( {1,P+1} );
    S.insert( {1,P+1} );

    while (U--) {
        char cmd; scanf(" %c",&cmd);
        if (cmd == 'U') {
            int d; scanf("%d",&d);
            interval ans = T.leftmost(d);
            printf("%d\n",ans.zac);
            if (ans.zac != -1) {
                T.erase(ans);
                S.erase(ans);
                if (ans.dlzka() > d) {
                    T.insert({ans.zac+d,ans.kon});
                    S.insert({ans.zac+d,ans.kon});
                }
            }
        } else {
            int x, y; scanf("%d%d",&x,&y); ++y;
            auto lo = S.lower_bound({x,0});
            if (lo != S.begin()) --lo;
            if (lo != S.end() && !intersect_or_touch(*lo,{x,y})) ++lo;
            auto hi = lo;
            while (hi != S.end() && intersect_or_touch(*hi,{x,y})) ++hi;
            vector<interval> relevantne(lo,hi);
            for (auto in : relevantne) { T.erase(in); S.erase(in); }
            interval novy = {x,y};
            if (!relevantne.empty()) { novy.zac = min(novy.zac, relevantne.front().zac); novy.kon = max(novy.kon, relevantne.back().kon); }
            T.insert(novy); S.insert(novy); 
        }
    }
}
